package	jp.co.sds_corp.util.calc;

import java.math.BigDecimal;

/**
* 計算式の要素を保持します。
*/
public class Operator
{
	public static final int	TYPE_PLUS		= 1;
	public static final int	TYPE_MINUS		= 2;
	public static final int	TYPE_MULTIPLY	= 3;
	public static final int	TYPE_DIVIDE		= 4;
	String ope;
	int type;

	public Operator( int var ) {
		this.type = var;
	}

	public Operator( String var ) throws SyntaxException {
		ope = var;
		if ( var.equals( "+" )) {
			this.type = TYPE_PLUS;
		} else
		if ( var.equals( "-" )) {
			this.type = TYPE_MINUS;
		} else
		if ( var.equals( "*" )) {
			this.type = TYPE_MULTIPLY;
		} else
		if ( var.equals( "/" )) {
			this.type = TYPE_DIVIDE;
		} else {
			throw( new SyntaxException( "symbol not recognize.[" + var + "]" ));
		}
	}

	public BigDecimal calc( BigDecimal var1, BigDecimal var2 ) {
		BigDecimal ret = null;
		switch ( type ) {
		case TYPE_PLUS:
			ret = var1.add( var2 );
			break;
		case TYPE_MINUS:
			ret = var1.subtract( var2 );
			break;
		case TYPE_MULTIPLY:
			ret = var1.multiply( var2 );
			break;
		case TYPE_DIVIDE:
			ret = var1.divide( var2, var1.scale()+9,
							BigDecimal.ROUND_HALF_DOWN );
			break;
		}
		return ret;
	}

	public String getSymbol() {
		return ope;
	}

	public int getLevel() {
		int nRet = -1;
		switch ( type ) {
		case TYPE_PLUS:
		case TYPE_MINUS:
			nRet = 1;
			break;
		case TYPE_MULTIPLY:
		case TYPE_DIVIDE:
			nRet = 2;
			break;
		}
		return nRet;
	}

	public int compareTo( Operator cmp ) {
		return getLevel() - cmp.getLevel();
	}

	public int hashCode() {
		return getLevel();
	}

	public boolean equals( Object cmp ) {
		if (!( cmp instanceof Operator )) {
			return false;
		}
		return getLevel() == ((Operator )cmp).getLevel();
	}

}
