package jp.co.sds_corp.util.config;

import java.util.List;

public class ConfigUtil
{
	public static String getProperty( IConfiguration config, String name )
		throws Exception
	{
		IConfiguration ele = null;
		try {
			List<IConfiguration> list = config.listChild("property");
			for (IConfiguration child : list) {
				String nm = child.getAttributes().get("name");
				if (nm != null && nm.equals(name)) {
					ele = child;
					break;
				}
			}
		} catch (Exception ex) {
			return null;
		}
		if (ele == null) {
			return null;
		}
		String ret = ele.getAttributes().get("value");
		return ret;
	}

	public static Integer getIntProperty( IConfiguration config, String name )
		throws Exception
	{
		String var = getProperty(config, name);
		if (var == null) {
			return null;
		}
		Integer ret = null;
		try {
			ret = Integer.valueOf(var);
		} catch (Exception ex) {
			throw(new Exception("illegal format[" + var + "]"));
		}
		return ret;
	}

	public static Long getLongProperty( IConfiguration config, String name )
		throws Exception
	{
		String var = getProperty(config, name);
		if (var == null) {
			return null;
		}
		Long ret = null;
		try {
			ret = Long.valueOf(var);
		} catch (Exception ex) {
			throw(new Exception("illegal format[" + var + "]"));
		}
		return ret;
	}

	public static Boolean getBooleanProperty( IConfiguration config, String name )
		throws Exception
	{
		String var = getProperty(config, name);
		if (var == null) {
			return null;
		}
		Boolean ret = null;
		try {
			ret = Boolean.valueOf(var);
		} catch (Exception ex) {
			throw(new Exception("illegal format[" + var + "]"));
		}
		return ret;
	}

	public static Integer getIntAttribute( IConfiguration config, String name )
		throws Exception
	{
		String var = config.getAttributes().get(name);
		if (var == null || var.length() == 0) {
			return null;
		}
		Integer ret;
		try {
			ret = Integer.valueOf(var);
		} catch (Exception ex) {
			throw(new Exception("illegal format " + name + " [" + var + "]"));
		}
		return ret;
	}

	public static Long getLongAttribute( IConfiguration config, String name )
		throws Exception
	{
		String var = config.getAttributes().get(name);
		if (var == null || var.length() == 0) {
			return null;
		}
		Long ret;
		try {
			ret = Long.valueOf(var);
		} catch (Exception ex) {
			throw(new Exception("illegal format " + name + " [" + var + "]"));
		}
		return ret;
	}

	public static Boolean getBooleanAttribute( IConfiguration config, String name )
		throws Exception
	{
		String var = config.getAttributes().get(name);
		if (var == null || var.length() == 0) {
			return null;
		}
		Boolean ret;
		try {
			ret = Boolean.valueOf(var);
		} catch (Exception ex) {
			throw(new Exception("illegal format " + name + " [" + var + "]"));
		}
		return ret;
	}

	public static String getChildText( IConfiguration config, String name )
		throws Exception
	{
		IConfiguration ele = null;
		try {
			ele = config.getChild(name);
		} catch (Exception ex) {
			return null;
		}
		if (ele == null) {
			return null;
		}
		String ret = ele.get();
		if (ret != null) {
			ret = ret.trim();
		}
		return ret;
	}

}
