package	jp.co.sds_corp.util.config;

/**
* 設定ファイルで指定されたパラメタを、{@link #init}メソッドで渡された
* {@link IConfiguration} objectから読み込むことが出来ます。
*/
public interface IConfigurable
{
	/**
	* 実装クラスがインスタンス化される時に呼び出されます。
	* IConfigurationのインターフェイスを用いて
	* 自身の設定情報を反映してください。
	* @param	config	設定ファイル中のそのモジュールに関する記述の
						コンテキストを表すIConfigurationオブジェクト
	*/
	public void init( IConfiguration config )
			throws UnspecifiedPropertyException,
				   ConfigurationFormatException,
				   Exception;
}
