package jp.co.sds_corp.util.crypt;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

import javax.crypto.Cipher;

import jp.co.sds_corp.util.log.CmnLogFactory;
import jp.co.sds_corp.util.log.CmnLogger;

public class BlockCipher
{
	CmnLogger logger = CmnLogFactory.getInstance().getLogger(this);
	Cipher cipher;
	int blockSize;

	public BlockCipher(Cipher cipher, int blockSize) {
		this.cipher = cipher;
		this.blockSize = blockSize;
	}

	public byte[] doFinal(byte[] src) throws Exception {
		byte[] result = null;
		if (blockSize < 0) {
			result = cipher.doFinal(src);
			return result;
		}

		List<Byte> resList = new ArrayList<Byte>();
		int pos = 0;
		byte[] srcBuf;
		for ( ;; ) {
			int len = src.length - pos;
			if (len > blockSize) {
				len = blockSize;
			}
			srcBuf = Arrays.copyOfRange(src, pos, pos + len);
			byte[] resBuf = cipher.doFinal(srcBuf, 0, len);
			pos += len;
			for (byte b : resBuf) {
				resList.add(b);
			}
			if (pos >= src.length) {
				break;
			}
		}
		result = new byte[resList.size()];
		for (int i = 0; i < resList.size(); i++) {
			result[i] = resList.get(i);
		}
		return result;
	}

}
