package	jp.co.sds_corp.util.device;

/**
* メモリの使用状況を保持します。
*/
public class MemoryUsage
{
	long	maxSize;
	long	usedSize;
	long	freeSize;
	long	cacheSize;	// キャッシュサイズ
	long	maxSwapSize;
	long	usedSwapSize;
	long	freeSwapSize;

	/**
	* 最大サイズ(maxSize)を設定します。
	* @param	var		設定するデータ
	*/
	void setMaxSize( long var ) {
		this.maxSize = var;
	}
	/**
	* 最大サイズ(maxSize)を取得します。
	* @return	maxSizeの内容
	*/
	public long getMaxSize() {
		return maxSize;
	}

	/**
	* 使用済みサイズ(usedSize)を設定します。
	* @param	var		設定するデータ
	*/
	void setUsedSize( long var ) {
		this.usedSize = var;
	}
	/**
	* 使用済みサイズ(usedSize)を取得します。
	* @return	usedSizeの内容
	*/
	public long getUsedSize() {
		return usedSize;
	}

	/**
	* 未使用サイズ(freeSize)を設定します。
	* @param	var		設定するデータ
	*/
	void setFreeSize( long var ) {
		this.freeSize = var;
	}
	/**
	* 未使用サイズ(freeSize)を取得します。
	* @return	freeSizeの内容
	*/
	public long getFreeSize() {
		return freeSize;
	}

	/**
	* キャッシュサイズ(cacheSize)を設定します。
	* @param	var		設定するデータ
	*/
	void setCacheSize( long var ) {
		this.cacheSize = var;
	}
	/**
	* キャッシュサイズ(cacheSize)を取得します。
	* @return	cacheSizeの内容
	*/
	public long getCacheSize() {
		return cacheSize;
	}

	/**
	* 最大スワップサイズ(maxSwapSize)を設定します。
	* @param	var		設定するデータ
	*/
	void setMaxSwapSize( long var ) {
		this.maxSwapSize = var;
	}
	/**
	* 最大スワップサイズ(maxSwapSize)を取得します。
	* @return	maxSwapSizeの内容
	*/
	public long getMaxSwapSize() {
		return maxSwapSize;
	}

	/**
	* 使用済みスワップサイズ(usedSwapSize)を設定します。
	* @param	var		設定するデータ
	*/
	void setUsedSwapSize( long var ) {
		this.usedSwapSize = var;
	}
	/**
	* 使用済みスワップサイズ(usedSwapSize)を取得します。
	* @return	usedSwapSizeの内容
	*/
	public long getUsedSwapSize() {
		return usedSwapSize;
	}

	/**
	* 未使用スワップサイズ(freeSwapSize)を設定します。
	* @param	var		設定するデータ
	*/
	void setFreeSwapSize( long var ) {
		this.freeSwapSize = var;
	}
	/**
	* 未使用スワップサイズ(freeSwapSize)を取得します。
	* @return	freeSwapSizeの内容
	*/
	public long getFreeSwapSize() {
		return freeSwapSize;
	}

}
