package	jp.co.sds_corp.util.device;

/**
* プロセスの状況を保持します。
*/
public class ProcessInfo
{
	int	pid;	// プロセスID
	int	parentId;	// 親プロセスID
	int	uid;	// ユーザID
	int	gid;	// グループID
	int	priority;	// 優先度
	int	nice;	// nice値
	long	size;	// メモリ使用量
	long	swapSize;	// スワップアウトされたサイズ
	int	status;	// 状態
	long	time;	// 起動してからの時間
	double	cpuTime;	// CPU使用率
	String	command;	// コマンドライン
	String	environ;	// 環境変数

	/**
	* プロセスID(pid)を設定します。
	* @param	var		設定するデータ
	*/
	void setPid( int var ) {
		this.pid = var;
	}
	/**
	* プロセスID(pid)を取得します。
	* @return	pidの内容
	*/
	public int getPid() {
		return pid;
	}

	/**
	* 親プロセスID(parentId)を設定します。
	* @param	var		設定するデータ
	*/
	void setParentId( int var ) {
		this.parentId = var;
	}
	/**
	* 親プロセスID(parentId)を取得します。
	* @return	parentIdの内容
	*/
	public int getParentId() {
		return parentId;
	}

	/**
	* ユーザID(uid)を設定します。
	* @param	var		設定するデータ
	*/
	void setUid( int var ) {
		this.uid = var;
	}
	/**
	* ユーザID(uid)を取得します。
	* @return	uidの内容
	*/
	public int getUid() {
		return uid;
	}

	/**
	* グループID(gid)を設定します。
	* @param	var		設定するデータ
	*/
	void setGid( int var ) {
		this.gid = var;
	}
	/**
	* グループID(gid)を取得します。
	* @return	gidの内容
	*/
	public int getGid() {
		return gid;
	}

	/**
	* 優先度(priority)を設定します。
	* @param	var		設定するデータ
	*/
	void setPriority( int var ) {
		this.priority = var;
	}
	/**
	* 優先度(priority)を取得します。
	* @return	priorityの内容
	*/
	public int getPriority() {
		return priority;
	}

	/**
	* nice値(nice)を設定します。
	* @param	var		設定するデータ
	*/
	void setNice( int var ) {
		this.nice = var;
	}
	/**
	* nice値(nice)を取得します。
	* @return	niceの内容
	*/
	public int getNice() {
		return nice;
	}

	/**
	* メモリ使用量(size)を設定します。
	* @param	var		設定するデータ
	*/
	void setSize( long var ) {
		this.size = var;
	}
	/**
	* メモリ使用量(size)を取得します。
	* @return	sizeの内容
	*/
	public long getSize() {
		return size;
	}

	/**
	* スワップアウトされたサイズ(swapSize)を設定します。
	* @param	var		設定するデータ
	*/
	void setSwapSize( long var ) {
		this.swapSize = var;
	}
	/**
	* スワップアウトされたサイズ(swapSize)を取得します。
	* @return	swapSizeの内容
	*/
	public long getSwapSize() {
		return swapSize;
	}

	/**
	* 状態(status)を設定します。
	* @param	var		設定するデータ
	*/
	void setStatus( int var ) {
		this.status = var;
	}
	/**
	* 状態(status)を取得します。
	* @return	statusの内容
	*/
	public int getStatus() {
		return status;
	}

	/**
	* 起動してからの時間(time)を設定します。
	* @param	var		設定するデータ
	*/
	void setTime( long var ) {
		this.time = var;
	}
	/**
	* 起動してからの時間(time)を取得します。
	* @return	timeの内容
	*/
	public long getTime() {
		return time;
	}

	/**
	* CPU使用率(cpuTime)を設定します。
	* @param	var		設定するデータ
	*/
	void setCpuTime( double var ) {
		this.cpuTime = var;
	}
	/**
	* CPU使用率(cpuTime)を取得します。
	* @return	cpuTimeの内容
	*/
	public double getCpuTime() {
		return cpuTime;
	}

	/**
	* コマンドライン(command)を設定します。
	* @param	var		設定するデータ
	*/
	void setCommand( String var ) {
		this.command = var;
	}
	/**
	* コマンドライン(command)を取得します。
	* @return	commandの内容
	*/
	public String getCommand() {
		return command;
	}

	/**
	* 環境変数(environ)を設定します。
	* @param	var		設定するデータ
	*/
	void setEnviron( String var ) {
		this.environ = var;
	}
	/**
	* 環境変数(environ)を取得します。
	* @return	environの内容
	*/
	public String getEnviron() {
		return environ;
	}

}
