package jp.co.sds_corp.util.diag;

import java.io.File;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.List;

import jp.co.sds_corp.util.log.ConsoleLogger;

public class FileDiagnostics
{
	ConsoleLogger logger = ConsoleLogger.getLogger(this);
	DecimalFormat df = new DecimalFormat("#,##0");

	public void displayFilesystems() {
		List<String> list = getFilesystems();
		for (String msg : list) {
			logger.info(msg);
		}
	}
	public List<String> getFilesystems() {
		ArrayList<String> ret = new ArrayList<String>();
		ret.add("=== filesystems ===");
		File[] roots = File.listRoots();
		for (File root : roots) {
			ret.add(getFilesystem(root));
		}
		return ret;
	}

	public String getFilesystem(File root) {
		String ret = root.getPath()
				+ " free=" + df.format(root.getFreeSpace())
				+ " usable=" + df.format(root.getUsableSpace())
				+ " total=" + df.format(root.getTotalSpace());
		return ret;
	}

}
