package	jp.co.sds_corp.util.file;

import java.io.File;
import java.io.FilenameFilter;
import java.util.regex.Pattern;

/**
* 正規表現を使用したファイル名フィルタです。
*/
public class RegexFilenameFilter implements FilenameFilter
{
	String pattern;
	Pattern ptn;

	protected RegexFilenameFilter() {
	}

	/**
	* 指定されたパターンで、ファイル名フィルタを生成します。
	* @param	pattern	パターン
	*/
	public RegexFilenameFilter( String pattern ) {
		setPattern( pattern );
	}

	/**
	* パターンを設定します。
	* @param	pattern	パターン
	*/
	public void setPattern( String pattern ) {
		this.pattern = pattern;
		ptn = Pattern.compile( pattern );
	}

	/**
	* パターンを取得します。
	* @return	パターン
	*/
	public String getPattern() {
		return pattern;
	}

	/**
	* 指定されたファイルをファイルリストに含めるかどうかをテストします。
	* @param	path	ファイルが見つかったディレクトリ
	* @param	name	ファイルの名前
	*/
	public boolean accept( File path, String name ) {
		boolean bRet = ptn.matcher( name ).matches();
		return bRet;
	}

}
