package jp.co.sds_corp.util.config;

import jp.co.sds_corp.test.BasicTestCase;
import jp.co.sds_corp.util.log.CmnLogFactory;
import jp.co.sds_corp.util.log.CmnLogger;

public class ConfigUtilTest extends BasicTestCase
{
	CmnLogger logger = CmnLogFactory.getInstance().getLogger(this);
	IConfiguration doc;
	IConfiguration config;

	public void setUp() throws Exception {
		super.setUp();
		doc = DOMConfiguration.findResource("utiltest.xml");
		config = doc.getChild("testConfig");
	}

	public void testGetProperty1() throws Exception {
		String ret = ConfigUtil.getProperty(config, "property1");
		assertEquals("property", "val1", ret);
	}

	public void testGetPropertyErr1() throws Exception {
		String ret = ConfigUtil.getProperty(config, "propertyErr1");
		assertEquals("property", (String )null, ret);
	}

	public void testGetIntProperty1() throws Exception {
		Integer ret = ConfigUtil.getIntProperty(config, "intProperty1");
		assertEquals("property", 123, ret.intValue());
	}

	public void testGetIntPropertyErr1() throws Exception {
		try {
			ConfigUtil.getIntProperty(config, "intPropertyErr1");
			fail("no error!");
		} catch (Exception ex) {
			logger.info("expected.", ex);
		}
	}

	public void testGetIntPropertyErr2() throws Exception {
		Integer ret = ConfigUtil.getIntProperty(config, "intPropertyErr2");
		assertEquals("property", (Integer )null, ret);
	}

	public void testGetLongProperty1() throws Exception {
		Long ret = ConfigUtil.getLongProperty(config, "longProperty1");
		assertEquals("property", 234, ret.longValue());
	}

	public void testGetLongPropertyErr1() throws Exception {
		try {
			ConfigUtil.getLongProperty(config, "longPropertyErr1");
			fail("no error!");
		} catch (Exception ex) {
			logger.info("expected.", ex);
		}
	}

	public void testGetLongPropertyErr2() throws Exception {
		Long ret = ConfigUtil.getLongProperty(config, "longPropertyErr2");
		assertEquals("property", (Long )null, ret);
	}

	public void testGetBooleanProperty1() throws Exception {
		Boolean ret = ConfigUtil.getBooleanProperty(config, "booleanProperty1");
		assertEquals("property", true, ret.booleanValue());
	}

	public void testGetBooleanPropertyErr1() throws Exception {
		Boolean ret = ConfigUtil.getBooleanProperty(config, "booleanPropertyErr1");
		assertEquals("property", false, ret.booleanValue());
/*
		try {
			ConfigUtil.getBooleanProperty(config, "booleanPropertyErr1");
			fail("no error!");
		} catch (Exception ex) {
			logger.info(this, "expected.", ex);
		}
*/
	}

	public void testGetBooleanPropertyErr2() throws Exception {
		Boolean ret = ConfigUtil.getBooleanProperty(config, "booleanPropertyErr2");
		assertEquals("property", (Boolean )null, ret);
	}

	public void testGetIntAttribute1() throws Exception {
		Integer ret = ConfigUtil.getIntAttribute(config, "intAttr");
		assertEquals("attribute", 345, ret.intValue());
	}

	public void testGetIntAttributeErr1() throws Exception {
		try {
			ConfigUtil.getIntAttribute(config, "intAttrErr");
			fail("no error!");
		} catch (Exception ex) {
			logger.info("expected.", ex);
		}
	}

	public void testGetIntAttributeErr2() throws Exception {
		try {
			Integer ret = ConfigUtil.getIntAttribute(config, "intAttrErr1");
			logger.trace("ret=" + ret);
			fail("no error!");
		} catch (Exception ex) {
			logger.info("expected.", ex);
		}
	}

	public void testGetLongAttribute1() throws Exception {
		Long ret = ConfigUtil.getLongAttribute(config, "longAttr");
		assertEquals("attribute", 456, ret.longValue());
	}

	public void testGetLongAttributeErr1() throws Exception {
		try {
			ConfigUtil.getLongAttribute(config, "longAttrErr");
			fail("no error!");
		} catch (Exception ex) {
			logger.info("expected.", ex);
		}
	}

	public void testGetLongAttributeErr2() throws Exception {
		try {
			Long ret = ConfigUtil.getLongAttribute(config, "longAttrErr1");
			logger.trace("ret=" + ret);
			fail("no error!");
		} catch (Exception ex) {
			logger.info("expected.", ex);
		}
	}

	public void testGetBooleanAttribute1() throws Exception {
		Boolean ret = ConfigUtil.getBooleanAttribute(config, "boolAttr");
		assertEquals("attribute", true, ret.booleanValue());
	}

	public void testGetBooleanAttributeErr1() throws Exception {
		Boolean ret = ConfigUtil.getBooleanAttribute(config, "boolAttrErr");
		assertEquals("attribute", false, ret.booleanValue());
/*
		try {
			ConfigUtil.getBooleanAttribute(config, "boolAttrErr");
			fail("no error!");
		} catch (Exception ex) {
			logger.info(this, "expected.", ex);
		}
*/
	}

	public void testGetBooleanAttributeErr2() throws Exception {
		try {
			Boolean ret = ConfigUtil.getBooleanAttribute(config, "boolAttrErr1");
			logger.trace("ret=" + ret);
			fail("no error!");
		} catch (Exception ex) {
			logger.info("expected.", ex);
		}
	}

}
