package jp.co.sds_corp.util.config;

import java.util.List;

import jp.co.sds_corp.test.BasicTestCase;
import jp.co.sds_corp.util.log.CmnLogFactory;
import jp.co.sds_corp.util.log.CmnLogger;

public class DOMConfigTest extends BasicTestCase
{
	CmnLogger logger = CmnLogFactory.getInstance().getLogger(this);
	IConfiguration doc;
	IConfiguration config;

	public void setUp() throws Exception {
		super.setUp();
		doc = DOMConfiguration.findResource("utiltest.xml");
		config = doc.getChild("testConfig");
	}

	public void testListChild() throws Exception {
		List<IConfiguration> list = doc.listChild( "list1" );
		assertEquals( "list.size", 2, list.size());
	}

	public void testReplace1() throws Exception {
		String ret = doc.get( "replace1" );
		logger.debug("replace1=" + ret);
		String expected = System.getProperty( "user.home" ).replaceAll("\\\\", "");
		expected += "/aa";
		assertEquals( "replace1", expected, ret );
	}

	public void testReplace2() throws Exception {
		String ret = doc.get( "replace2" );
		logger.debug("replace2=" + ret);
		assertEquals( "replace2", "val1/bb", ret );
	}

}
