package jp.co.sds_corp.util.log;

import java.text.DecimalFormat;
import java.util.logging.Level;

import jp.co.sds_corp.test.BasicTestCase;

public class CmnLoggerTest extends BasicTestCase
{
	ConsoleLogger console = ConsoleLogger.getLogger(this);
	CmnLogger logger = CmnLogFactory.getInstance().getLogger(this);

	public void setUp() throws Exception {
		super.setUp();

		console.setLevel( Level.ALL );
	}

    /**
     */
    public void testDebug1() throws Exception {
		console.log( "main thread=" + Thread.currentThread().getId() );
		logger.debug( "debug msg" );
    }

    /**
     */
    public void testDebug2() throws Exception {
		Exception ex = new Exception( "test exception" );
		logger.debug( "debug msg", ex );
    }

    /**
     */
    public void testDebug3() throws Exception {
    	CmnLogger logger = CmnLogFactory.getInstance().getLogger(CmnLogger.class);
    	logger.debug( "debug test msg" );
    }

    /**
     */
    public void testDebug4() throws Exception {
    	CmnLogger logger = CmnLogFactory.getInstance().getLogger("jp.co.sds_corp.package.Class");
		logger.debug( "debug test msg" );
    }

    /**
     */
    public void testInfo1() throws Exception {
		logger.info( "info msg" );
    }

    /**
     */
    public void testInfo2() throws Exception {
		Exception ex = new Exception( "test exception" );
		logger.info( "info msg", ex );
    }

    /**
     */
    public void testWarn1() throws Exception {
		logger.warn( "warn msg" );
    }

    /**
     */
    public void testWarn2() throws Exception {
		Exception ex = new Exception( "test exception" );
		logger.warn( "warn msg", ex );
    }

    /**
     */
    public void testError1() throws Exception {
		logger.error( "error msg" );
    }

    /**
     */
    public void testError2() throws Exception {
		Exception ex1 = new Exception( "test exception1" );
		Exception ex2 = new Exception( "test exception2", ex1 );
		logger.error( "error msg", ex2 );
    }

    /**
     */
    public void testSql() throws Exception {
		logger.sql( "select *** from table" );
		logger.sql( "select *** from table2" );
    }

    /**
     */
    public void testTest2() throws Exception {
    	CmnLogger logger = CmnLogFactory.getInstance().getLogger("jp.co.sds_corp.TEST");
		logger.info( "[INCLUDE] test" );
    }

    /**
     */
    public void testTest3() throws Exception {
    	CmnLogger logger = CmnLogFactory.getInstance().getLogger("jp.co.sds_corp.TEST");
		logger.info( "[not INCLUDE]" );
    }

    /**
     */
    public void testTest4() throws Exception {
    	CmnLogger logger = CmnLogFactory.getInstance().getLogger("jp.co.sds_corp.TEST");
		logger.info( "[INCLUDE] and [EXCLUDE]" );
    }

    /**
     */
    public void testTest5() throws Exception {
    	CmnLogger logger = CmnLogFactory.getInstance().getLogger("jp.co.sds_corp.TEST");
		logger.debug( "[INCLUDE] but DEBUG" );
    }

    /**
     */
    public void testLineWrap() throws Exception {
		StringBuilder logMsg = new StringBuilder();
		DecimalFormat df = new DecimalFormat( "000000000" );
		for ( int i = 0; i < 210; i++ ) {
			logMsg.append( df.format( i ) + "," );
		}
		logger.debug( logMsg.toString() );
    }

    /**
     */
    public void testNull1() throws Exception {
		logger.trace( "test", (Throwable )null );
		logger.debug( "test", (Throwable )null );
		logger.detail( "test", (Throwable )null );
		logger.info( "test", (Throwable )null );
		logger.warn( "test", (Throwable )null );
		logger.error( "test", (Throwable )null );
    }

    /**
     */
    public void testNull2() throws Exception {
		logger.exception( null );
    }

}
