package jp.co.sds_corp.util.log;

import java.util.logging.Level;

import jp.co.sds_corp.test.BasicTestCase;

public class ConsoleLoggerTest extends BasicTestCase
{
	ConsoleLogger logger = ConsoleLogger.getLogger(this);

	public void setUp() throws Exception {
		super.setUp();
		logger.setLevel( Level.ALL );
	}

    /**
     */
    public void testDebug1() throws Exception {
		logger.debug( "debug msg" );
    }

    /**
     */
    public void testDebug2() throws Exception {
		Exception ex = new Exception( "test exception" );
		logger.debug( "debug msg", ex );
    }

    /**
     */
    public void testDebug3() throws Exception {
    	ConsoleLogger logger = ConsoleLogger.getLogger(ConsoleLogger.class);
		logger.debug( "debug test msg" );
    }

    /**
     */
    public void testDebug4() throws Exception {
    	ConsoleLogger logger = ConsoleLogger.getLogger("jp.co.smbc.aidw.package.Class");
		logger.debug( "debug test msg" );
    }

    /**
     */
    public void testInfo1() throws Exception {
		logger.info( "info msg" );
    }

    /**
     */
    public void testInfo2() throws Exception {
		Exception ex = new Exception( "test exception" );
		logger.info( "info msg", ex );
    }

    /**
     */
    public void testError1() throws Exception {
		logger.error( "error msg" );
    }

    /**
     */
    public void testError2() throws Exception {
		Exception ex1 = new Exception( "test exception1" );
		Exception ex2 = new Exception( "test exception2", ex1 );
		logger.error( "error msg", ex2 );
    }

    /**
     */
    public void testNull1() throws Exception {
    	Exception ex = null;
		logger.debug( "debug msg", ex );
		logger.info( "info msg", ex );
		logger.error( "error msg", ex );
    }

    /**
     */
    public void testNull2() throws Exception {
		logger.exception( null );
    }

}
