package jp.co.sds_corp.util.log;

import java.util.logging.Level;
import java.util.logging.LogManager;

import jp.co.sds_corp.test.BasicTestCase;

public class Logger2Test extends BasicTestCase
{
	ConsoleLogger console = ConsoleLogger.getLogger(this);
	CmnLogger logger = CmnLogFactory.getInstance().getLogger(this);

    /**
     */
    public void testDebug1() throws Exception {
		logger.debug( "debug msg" );

		console.log( "reset LogManager" );
		LogManager manager = LogManager.getLogManager();
		manager.reset();

		System.err.println( "err msg2" );
		System.out.println( "out msg2" );
		console.log( "debug msg2" );
		logger.debug( "debug msg2" );

		CmnLogFactory.getInstance().loadConfig();
		logger.debug( "debug msg3" );
    }

    /**
     */
    public void testLoggable1() throws Exception {
		CmnLogger target;
		target = CmnLogFactory.getInstance().getLogger( "jp.co.sds_corp" );
		logger.info( "jp.co.sds_corp=" + target.getLogger().getLevel());

		String category = "jp.co.sds_corp.sample.SampleLog";
		target = CmnLogFactory.getInstance().getLogger( category );
		logger.info( "sample level=" + target.getLogger().getLevel());
		logger.info( "sample FINE=" + target.isLoggable( Level.FINE ));
		logger.info( "sample FINER=" + target.isLoggable( Level.FINER ));
		logger.info( "sample FINEST=" + target.isLoggable( Level.FINEST ));
		logger.info( "INFO" );
		logger.detail( "FINE" );
		logger.debug( "FINER" );
		logger.trace( "FINEST" );

		CmnLogger logger2 = CmnLogFactory.getInstance().getLogger("jp.co.sds_corp.sample2.Smaple2");

		logger2.info( "INFO" );
		logger2.detail( "FINE" );
		logger2.debug( "FINER" );
		logger2.trace( "FINEST" );

		target = CmnLogFactory.getInstance().getLogger( "jp.co.sds_corp.PERF.jp.co.sds_corp.test" );
		logger.info( "PERF FINE=" + target.isLoggable( Level.FINE ));
		logger.info( "PERF FINER=" + target.isLoggable( Level.FINER ));
		logger.info( "PERF FINEST=" + target.isLoggable( Level.FINEST ));
	}

}
