package jp.co.sds_corp.util.log;

import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import jp.co.sds_corp.test.BasicTestCase;

public class StressLogTest extends BasicTestCase
{
	ConsoleLogger console = ConsoleLogger.getLogger(this);
	CmnLogger logger = CmnLogFactory.getInstance().getLogger(this);
	List<LogTester> listTester = new ArrayList<LogTester>();
	long	cost;

	class LogTester implements Runnable
	{
		Thread thread;
		boolean stopped;
		public void run() {
			long id = Thread.currentThread().getId();
			try {
				Thread.sleep( 10 );
			} catch ( InterruptedException ex ) {
			}
			Date start = new Date();
			logger.info( "IN param" );
			for ( int i = 0; i < 10; i++ ) {
				if ( isStop()) {
					break;
				}
				logger.trace( "trace message" );
			}
			Exception ex1 = new Exception();
			Exception ex2 = new Exception( ex1 );
			Exception ex3 = new Exception( ex2 );
			logger.error( "error message", ex3 );

			logger.info( "OUT result" );
			Date end = new Date();
			long cost = end.getTime() - start.getTime();
			console.info( id + " cost=" + cost );
			addCost( cost );
		}
		public synchronized boolean isStop() {
			return stopped;
		}
		public synchronized void setStop( boolean var ) {
			this.stopped = var;
		}
	}

    /**
     */
    public void putLog( int idx ) {
		DecimalFormat dfIdx = new DecimalFormat( "(000000) " );
		StringBuilder logMsg = new StringBuilder();
		logMsg.append( dfIdx.format( idx ));
		DecimalFormat df = new DecimalFormat( "000000000" );
		for ( int i = 0; i < 20; i++ ) {
			logMsg.append( df.format( i ) + "," );
		}
		logger.debug( logMsg.toString() );
    }

	synchronized void addCost( long var ) {
		cost += var;
	}

	public void setUp() {
		for ( int i = 0; i < 10; i++ ) {
			LogTester tester = new LogTester();
			tester.thread = new Thread( tester );
			listTester.add( tester );
		}
	}

    /**
     */
    public void testDebug1() throws Exception {
		console.info( "main thread=" + Thread.currentThread().getId() );

	   	for ( LogTester tester : listTester ) {
	   		tester.thread.start();
		}
    	for ( LogTester tester : listTester ) {
    		tester.thread.join();
    	}

		synchronized ( this ) {
			console.info( "total cost=" + cost );
		}
		logger.debug( "end of test." );
    }

    public void tearDown() {
    }
}
